<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseSupplier extends AbstractStructArrayBase
{
    /**
     * The CruiseSupplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseSupplier[]
     */
    public $CruiseSupplier;
    /**
     * Constructor method for ArrayOfJP_CruiseSupplier
     * @uses ArrayOfJP_CruiseSupplier::setCruiseSupplier()
     * @param \StructType\JP_CruiseSupplier[] $cruiseSupplier
     */
    public function __construct(array $cruiseSupplier = array())
    {
        $this
            ->setCruiseSupplier($cruiseSupplier);
    }
    /**
     * Get CruiseSupplier value
     * @return \StructType\JP_CruiseSupplier[]|null
     */
    public function getCruiseSupplier()
    {
        return $this->CruiseSupplier;
    }
    /**
     * Set CruiseSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseSupplier[] $cruiseSupplier
     * @return \ArrayType\ArrayOfJP_CruiseSupplier
     */
    public function setCruiseSupplier(array $cruiseSupplier = array())
    {
        foreach ($cruiseSupplier as $arrayOfJP_CruiseSupplierCruiseSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseSupplierCruiseSupplierItem instanceof \StructType\JP_CruiseSupplier) {
                throw new \InvalidArgumentException(sprintf('The CruiseSupplier property can only contain items of \StructType\JP_CruiseSupplier, "%s" given', is_object($arrayOfJP_CruiseSupplierCruiseSupplierItem) ? get_class($arrayOfJP_CruiseSupplierCruiseSupplierItem) : gettype($arrayOfJP_CruiseSupplierCruiseSupplierItem)), __LINE__);
            }
        }
        $this->CruiseSupplier = $cruiseSupplier;
        return $this;
    }
    /**
     * Add item to CruiseSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseSupplier $item
     * @return \ArrayType\ArrayOfJP_CruiseSupplier
     */
    public function addToCruiseSupplier(\StructType\JP_CruiseSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseSupplier) {
            throw new \InvalidArgumentException(sprintf('The CruiseSupplier property can only contain items of \StructType\JP_CruiseSupplier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CruiseSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CruiseSupplier
     */
    public function getAttributeName()
    {
        return 'CruiseSupplier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CruiseSupplier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
